
Blockly.Blocks['kbexten_ReadDigital'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(Blockly.Msg.kbexten_DigitalRead_MESSAGE)
        .appendField(new Blockly.FieldDropdown([["D1","29"],["D2","28"], ["D3","27"], ["D4","26"], ["D5","25"], ["D6","24"]]), "pin");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour("#2aa3b8");
 this.setTooltip("read digital");
 this.setHelpUrl("");
  }
};
Blockly.Blocks['kbexten_ReadAnalog'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(Blockly.Msg.kbexten_AnalogRead_MESSAGE)
        .appendField(new Blockly.FieldDropdown([["A1","29"],["A2","28"], ["A3","27"], ["A4","26"]]), "pin");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour("#2aa3b8");
 this.setTooltip("read analog from ....");
 this.setHelpUrl("");
  }
};
Blockly.Blocks['kbexten_ReadDistance'] = {
  init: function() {
    this.appendDummyInput()
        .appendField("Ultrasonic at pin");
    this.appendDummyInput()
        .appendField("Echo:")
        .appendField(new Blockly.FieldDropdown([["D1","29"],["D2","28"], ["D3","27"], ["D4","26"], ["D5","25"], ["D6","24"]]), "Echopin");
    this.appendDummyInput()
        .appendField("Trig:")
        .appendField(new Blockly.FieldDropdown([["D1","29"],["D2","28"], ["D3","27"], ["D4","26"], ["D5","25"], ["D6","24"]]), "Trigpin");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour("#2aa3b8");
 this.setTooltip("read analog from ....");
 this.setHelpUrl("");
  }
};
Blockly.Blocks['kbexten_WriteDigital'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(Blockly.Msg.kbexten_DigitalWrite_MESSAGE)
        .appendField(new Blockly.FieldDropdown([["D1","29"],["D2","28"], ["D3","27"], ["D4","26"], ["D5","25"], ["D6","24"]]), "pin");
    this.appendValueInput("Status")
      .setCheck("Number")
      .appendField("Status:");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_WriteDigital">
        <value name="Status">
          <shadow type="math_number">
            <field name="VALUE">0</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
// Blockly.Blocks['kbexten_ReadAnalogAll'] = {
//   init: function() {
//     this.appendDummyInput()
//         .appendField("Read All Sensor(A1-A4)");
//     this.setInputsInline(true);
//     this.setOutput(true, "Number");
//     this.setColour("#2aa3b8");
//  this.setTooltip("read analog All Sensor");
//  this.setHelpUrl("");
//   }
// };
Blockly.Blocks['kbexten_servo'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(Blockly.Msg.kbexten_Servo_MOTOR_MESSAGE)
        .appendField(new Blockly.FieldDropdown([["1","1"],["2","2"], ["3","3"], ["4","4"]]), "pin");
    this.appendValueInput("angle")
      .setCheck("Number")
      .appendField("At")
    this.appendDummyInput()
      .appendField("degree");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_servo">
        <value name="angle">
          <shadow type="math_number">
            <field name="VALUE">90</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_stop'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(Blockly.Msg.kbexten_MOTOR_Stop_MESSAGE);
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_stop">
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};

// Blockly.Blocks['kbexten_motor_stop_ch'] = {
//   init: function() {
//     this.appendDummyInput()
//       .appendField(Blockly.Msg.kbexten_MOTOR_Stop_CH_MESSAGE)
//       .appendField(new Blockly.FieldDropdown([["1","1"], ["2","2"]]), "ch")
//     this.setInputsInline(true);
//     this.setPreviousStatement(true, null);
//     this.setNextStatement(true, null);
//     this.setColour(330);
//     this.setTooltip("");
//   }
// };
Blockly.Blocks['kbexten_motor_forward'] = {
    init: function() {
      this.appendValueInput("speed")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_MOTOR_Forward_MESSAGE);
      this.appendDummyInput()
        .appendField("%");
      this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
      this.setInputsInline(true);
      this.setPreviousStatement(true, null);
      this.setNextStatement(true, null);
      this.setColour("#2aa3b8");
      this.setTooltip("");
    }
    ,
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_forward">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_forward2'] = {
  init: function() {
    this.appendValueInput("speed1")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_Motor1_Move_FA_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
      this.appendValueInput("speed2")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_Motor1_Move_FB_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  }
  ,
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_forward2">
        <value name="speed1">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="speed2">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_backward'] = {
  init: function() {
    this.appendValueInput("speed")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_MOTOR_Backward_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_backward">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};

Blockly.Blocks['kbexten_motor_backward2'] = {
  init: function() {
    this.appendValueInput("speed1")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_Motor1_Move_BA_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
      this.appendValueInput("speed2")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_Motor1_Move_BB_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  }
  ,
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_backward2">
        <value name="speed1">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="speed2">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_turn_left'] = {
  init: function() {
    this.appendValueInput("speed")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_MOTOR_turn_left_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_turn_left">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_turn_right'] = {
  init: function() {
    this.appendValueInput("speed")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_MOTOR_turn_right_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_turn_right">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_spin_left'] = {
  init: function() {
    this.appendValueInput("speed")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_MOTOR_spin_Left_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_spin_left">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_motor_spin_right'] = {
  init: function() {
    this.appendValueInput("speed")
      .setCheck("Number")
      .appendField(Blockly.Msg.kbexten_MOTOR_spin_Right_MESSAGE);
    this.appendDummyInput()
      .appendField("%");
    this.appendValueInput("time_delay")
        .setCheck("Number")
        .appendField(Blockly.Msg.kbexten_Delay_MESSAGE);
      this.appendDummyInput()
        .appendField("ms");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
    xmlToolbox: function() {
    return `
      <block type="kbexten_motor_spin_right">
        <value name="speed">
          <shadow type="math_number">
            <field name="VALUE">50</field>
          </shadow>
        </value>
        <value name="time_delay">
          <shadow type="math_number">
            <field name="VALUE">500</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_set_pin_sensor'] = {
  init: function() {
    this.appendDummyInput()
      .appendField("Set pin PID S1:")
      .appendField(new Blockly.FieldDropdown([["-","0"], ["A1","29"], ["A2","28"], ["A3","27"], ["A4","26"]]), "PID_S1");
    this.appendDummyInput()
      .appendField("S2:")
      .appendField(new Blockly.FieldDropdown([["-","0"], ["A1","29"], ["A2","28"], ["A3","27"], ["A4","26"]]), "PID_S2");
    this.appendDummyInput()
      .appendField("S3:")
      .appendField(new Blockly.FieldDropdown([["-","0"], ["A1","29"], ["A2","28"], ["A3","27"], ["A4","26"]]), "PID_S3");
    this.appendDummyInput()
      .appendField("S4:")
      .appendField(new Blockly.FieldDropdown([["-","0"], ["A1","29"], ["A2","28"], ["A3","27"], ["A4","26"]]), "PID_S4");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
};
Blockly.Blocks['KB_ExtenV2_set_min_PID'] = {
  init: function() {
    this.appendValueInput("Min_S1")
      .setCheck("Number")
      .appendField("Set Min value S1:");
    this.appendValueInput("Min_S2")
      .setCheck("Number")
      .appendField("S2:");
    this.appendValueInput("Min_S3")
      .setCheck("Number")
      .appendField("S3:");
    this.appendValueInput("Min_S4")
      .setCheck("Number")
      .appendField("S4:");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
  xmlToolbox: function() {
    return `
      <block type="KB_ExtenV2_set_min_PID">
        <value name="Min_S1">
          <shadow type="math_number">
            <field name="VALUE">80</field>
          </shadow>
        </value>
        <value name="Min_S2">
          <shadow type="math_number">
            <field name="VALUE">90</field>
          </shadow>
        </value>
        <value name="Min_S3">
          <shadow type="math_number">
            <field name="VALUE">100</field>
          </shadow>
        </value>
        <value name="Min_S4">
          <shadow type="math_number">
            <field name="VALUE">110</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['KB_ExtenV2_set_max_PID'] = {
  init: function() {
    this.appendValueInput("Max_S1")
      .setCheck("Number")
      .appendField("Set Max value S1:");
    this.appendValueInput("Max_S2")
      .setCheck("Number")
      .appendField("S2:");
    this.appendValueInput("Max_S3")
      .setCheck("Number")
      .appendField("S3:");
    this.appendValueInput("Max_S4")
      .setCheck("Number")
      .appendField("S4:");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
  xmlToolbox: function() {
    return `
      <block type="KB_ExtenV2_set_max_PID">
        <value name="Max_S1">
          <shadow type="math_number">
            <field name="VALUE">1000</field>
          </shadow>
        </value>
        <value name="Max_S2">
          <shadow type="math_number">
            <field name="VALUE">999</field>
          </shadow>
        </value>
        <value name="Max_S3">
          <shadow type="math_number">
            <field name="VALUE">998</field>
          </shadow>
        </value>
        <value name="Max_S4">
          <shadow type="math_number">
            <field name="VALUE">997</field>
          </shadow>
        </value>
      </block>
    `;
  }
};
Blockly.Blocks['kbexten_ReadLine'] = {
  init: function() {
    this.appendDummyInput()
        .appendField(" Read Line ");
    this.setInputsInline(true);
    this.setOutput(true, "Number");
    this.setColour("#2aa3b8");
 this.setTooltip("read analog from ....");
 this.setHelpUrl("");
  }
};
Blockly.Blocks['KB_ExtenV2_Run_PID'] = {
  init: function() {
    this.appendValueInput("Speed")
      .setCheck("Number")
      .appendField("Follow line at speed:");
    this.appendValueInput("KP")
      .setCheck("Number")
      .appendField("KP:");
    this.appendValueInput("KI")
      .setCheck("Number")
      .appendField("KI:");
    this.appendValueInput("KD")
      .setCheck("Number")
      .appendField("KD:");
    this.setInputsInline(true);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setColour("#2aa3b8");
    this.setTooltip("");
  },
  xmlToolbox: function() {
    return `
      <block type="KB_ExtenV2_Run_PID">
        <value name="Speed">
          <shadow type="math_number">
            <field name="VALUE">40</field>
          </shadow>
        </value>
        <value name="KP">
          <shadow type="math_number">
            <field name="VALUE">0.5</field>
          </shadow>
        </value>
        <value name="KI">
          <shadow type="math_number">
            <field name="VALUE">0.0</field>
          </shadow>
        </value>
        <value name="KD">
          <shadow type="math_number">
            <field name="VALUE">0.0</field>
          </shadow>
        </value>
      </block>
    `;
  }
};