
const kbexten_BEGIN = `DEV_I2C1.kbexten(0, 0x20)`;

Blockly.JavaScript['kbexten_ReadDigital'] = function(block) {
  var dropdown_pin = block.getFieldValue('pin');
  var code = `${kbexten_BEGIN}.readDigital(${dropdown_pin},0)`;
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['kbexten_ReadAnalog'] = function(block) {
  var dropdown_pin = block.getFieldValue('pin');
  var code = `${kbexten_BEGIN}.readAnalog(${dropdown_pin})`;
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['kbexten_ReadDistance'] = function(block) {
  var dropdown_Echopin = block.getFieldValue('Echopin');
  var dropdown_Trigpin = block.getFieldValue('Trigpin');
  var code = `${kbexten_BEGIN}.readDistance(${dropdown_Echopin},${dropdown_Trigpin})`;
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['kbexten_WriteDigital'] = function(block) {
  	var dropdown_ch = block.getFieldValue('pin');
    var value_Status = Blockly.JavaScript.valueToCode(block, 'Status', Blockly.JavaScript.ORDER_ATOMIC) || '0';
    var code = `${kbexten_BEGIN}.writeDigital(${dropdown_ch},${value_Status});\n`;
   return code;
};
// Blockly.JavaScript['kbexten_ReadAnalogAll'] = function(block) {
//   //var code = `${kbexten_BEGIN}.readDistance(${dropdown_Echopin},${dropdown_Trigpin})`;
//   var code = `${kbexten_BEGIN}.strBuff`;
//   return [code, Blockly.JavaScript.ORDER_NONE];
// };
Blockly.JavaScript['kbexten_servo'] = function(block) {
  	var dropdown_ch = block.getFieldValue('pin');
    var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
    var value_angle = Blockly.JavaScript.valueToCode(block, 'angle', Blockly.JavaScript.ORDER_ATOMIC) || '0';
    var code = `${kbexten_BEGIN}.setServoMotor(${dropdown_ch},${value_angle},${value_time_delay});\n`;
   return code;
};

Blockly.JavaScript['kbexten_motor_forward'] = function(block) {
   var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
   var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
   var code = `${kbexten_BEGIN}.setStateMotor(0,${value_speed},${value_time_delay});\n`;
   return code;
};
Blockly.JavaScript['kbexten_motor_backward'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(1,${value_speed},${value_time_delay});\n`;
   return code;
};
Blockly.JavaScript['kbexten_motor_forward2'] = function(block) {
  var value_speedA = Blockly.JavaScript.valueToCode(block, 'speed1', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_speedB = Blockly.JavaScript.valueToCode(block, 'speed2', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(6,${value_speedA},1);\n`;
  code += `${kbexten_BEGIN}.setStateMotor(7,${value_speedB},1);\n`;
  return code;
};
Blockly.JavaScript['kbexten_motor_backward2'] = function(block) {
  var value_speedA = Blockly.JavaScript.valueToCode(block, 'speed1', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_speedB = Blockly.JavaScript.valueToCode(block, 'speed2', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(8,${value_speedA},1);\n`;
  code += `${kbexten_BEGIN}.setStateMotor(9,${value_speedB},1);\n`;
  return code;
};
Blockly.JavaScript['kbexten_motor_turn_left'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(2,${value_speed},${value_time_delay});\n`;
   return code;
};

Blockly.JavaScript['kbexten_motor_turn_right'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(3,${value_speed},${value_time_delay});\n`;
   return code;
};

Blockly.JavaScript['kbexten_motor_spin_left'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(4,${value_speed},${value_time_delay});\n`;
   return code;
};

Blockly.JavaScript['kbexten_motor_spin_right'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'speed', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(5,${value_speed},${value_time_delay});\n`;
   return code;
};


Blockly.JavaScript['kbexten_motor_stop'] = function(block) { 
  var value_time_delay = Blockly.JavaScript.valueToCode(block, 'time_delay', Blockly.JavaScript.ORDER_ATOMIC) || '0';
  var code = `${kbexten_BEGIN}.setStateMotor(1,0,${value_time_delay});\n`;
   return code;
};
Blockly.JavaScript['kbexten_set_pin_sensor'] = function(block) {
  var dropdown_S1 = block.getFieldValue('PID_S1');
  var dropdown_S2 = block.getFieldValue('PID_S2');
  var dropdown_S3 = block.getFieldValue('PID_S3');
  var dropdown_S4 = block.getFieldValue('PID_S4');
  var code = `${kbexten_BEGIN}.set_pin_PID(${dropdown_S1},${dropdown_S2},${dropdown_S3},${dropdown_S4});\n`;
  
  return code;
};
Blockly.JavaScript['KB_ExtenV2_set_min_PID'] = function(block) {
  var value_S1 = Blockly.JavaScript.valueToCode(block, 'Min_S1', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S2 = Blockly.JavaScript.valueToCode(block, 'Min_S2', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S3 = Blockly.JavaScript.valueToCode(block, 'Min_S3', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S4 = Blockly.JavaScript.valueToCode(block, 'Min_S4', Blockly.JavaScript.ORDER_ATOMIC) || 0;

  var code = `${kbexten_BEGIN}.min_sensor_values[0] = ${value_S1};\n`;
  code += `${kbexten_BEGIN}.min_sensor_values[1] = ${value_S2};\n`;
  code += `${kbexten_BEGIN}.min_sensor_values[2] = ${value_S3};\n`;
  code += `${kbexten_BEGIN}.min_sensor_values[3] = ${value_S4};\n`;

  return code;
};
Blockly.JavaScript['KB_ExtenV2_set_max_PID'] = function(block) {
  var value_S1 = Blockly.JavaScript.valueToCode(block, 'Max_S1', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S2 = Blockly.JavaScript.valueToCode(block, 'Max_S2', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S3 = Blockly.JavaScript.valueToCode(block, 'Max_S3', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_S4 = Blockly.JavaScript.valueToCode(block, 'Max_S4', Blockly.JavaScript.ORDER_ATOMIC) || 0;

  var code = `${kbexten_BEGIN}.max_sensor_values[0] = ${value_S1};\n`;
  code += `${kbexten_BEGIN}.max_sensor_values[1] = ${value_S2};\n`;
  code += `${kbexten_BEGIN}.max_sensor_values[2] = ${value_S3};\n`;
  code += `${kbexten_BEGIN}.max_sensor_values[3] = ${value_S4};\n`;

  return code;
};
Blockly.JavaScript['kbexten_ReadLine'] = function(block) {
  //var dropdown_pin = block.getFieldValue('pin');
  var code = `${kbexten_BEGIN}.readLine()`;
  return [code, Blockly.JavaScript.ORDER_NONE];
};
Blockly.JavaScript['KB_ExtenV2_Run_PID'] = function(block) {
  var value_speed = Blockly.JavaScript.valueToCode(block, 'Speed', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_KP = Blockly.JavaScript.valueToCode(block, 'KP', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_KI = Blockly.JavaScript.valueToCode(block, 'KI', Blockly.JavaScript.ORDER_ATOMIC) || 0;
  var value_KD = Blockly.JavaScript.valueToCode(block, 'KD', Blockly.JavaScript.ORDER_ATOMIC) || 0;

  var code = `${kbexten_BEGIN}._Run_PID(${value_speed},${value_KP},${value_KI},${value_KD});\n`;

  return code;
};