


// This project clone form KidmotorV4 by ArtronShop

#include "kbexten.h"


kbexten::kbexten(int bus_ch, int dev_addr) {
	channel = bus_ch;
	address = dev_addr;
	polling_ms = 100;
}

void kbexten::init(void) {
	// set initialized flag
	this->initialized = true;
	
	// clear error flag
	this->error = false;
	
	// Clear
	memset(kbextenData, 0, 2);
	memset(strBuff, 0, 20);
	
}

int kbexten::prop_count(void) {
	// not supported
	return 0;
}

bool kbexten::prop_name(int index, char *name) {
	// not supported
	return false;
}

bool kbexten::prop_unit(int index, char *unit) {
	// not supported
	return false;
}

bool kbexten::prop_attr(int index, char *attr) {
	// not supported
	return false;
}

bool kbexten::prop_read(int index, char *value) {
	// not supported
	return false;
}

bool kbexten::prop_write(int index, char *value) {
	// not supported
	return false;
}
// --------------------------------------

// Start here
void kbexten::process(Driver *drv) {
	i2c = (I2CDev *)drv;
}

// Method
void kbexten::setStateMotor(uint8_t state, uint8_t speed,int time_delay) {
	if(speed < 0){speed = 0;}
	if(speed > 100){speed = 100;}
	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)20,(uint8_t)state,(uint8_t)speed};
	this->error = this->i2c->write(this->channel, this->address, dataA,4) ==  ESP_OK;
	vTaskDelay(time_delay / portTICK_RATE_MS);
}
void kbexten::setServoMotor(uint8_t ch, uint8_t degree,int time_delay) {
	if(degree == 0){degree = 1;}
	if(degree > 180){degree = 180;}
	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)ch,(uint8_t)degree};
	this->error = this->i2c->write(this->channel, this->address, dataA, 4) ==  ESP_OK;
	vTaskDelay(time_delay / portTICK_RATE_MS);
}
void kbexten::writeDigital(uint8_t ch,uint8_t status){
	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)0x07,(uint8_t)ch,(uint8_t)status};
	this->error = this->i2c->write(this->channel, this->address, dataA,4) ==  ESP_OK;
}
int kbexten::readDigital(uint8_t ch,uint8_t pinMode) {

	uint8_t dataIn[2]={0,0};

	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)0x08,(uint8_t)11};
	 this->error = this->i2c->write(this->channel, this->address,  dataA,3) ==  ESP_OK;
	this->error = this->i2c->read(this->channel, this->address, dataA,4 , dataIn, 2) ==  ESP_OK;

	return (dataIn[1] * 256 + dataIn[0]);
}

int kbexten::readAnalog(uint8_t ch) {

	uint8_t dataIn[2]={0,0};

	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)0x09,(uint8_t)ch};
	 this->error = this->i2c->write(this->channel, this->address,  dataA,3) ==  ESP_OK;
	this->error = this->i2c->read(this->channel, this->address, dataA,4 , dataIn, 2) ==  ESP_OK;

	return (dataIn[1] * 256 + dataIn[0]);
}
int kbexten::readDistance(uint8_t Echo,uint8_t Trig){
	uint8_t dataIn[2]={0,0};
	uint8_t dataA[4] = {(uint8_t)0xFF,(uint8_t)15,(uint8_t)Echo,(uint8_t) Trig};
	this->error = this->i2c->write(this->channel, this->address,  dataA,4) ==  ESP_OK;
	this->error = this->i2c->read(this->channel, this->address, dataA,4 , dataIn, 2) ==  ESP_OK;

	return (dataIn[1] * 256 + dataIn[0]);
}
void kbexten::motor(uint8_t ch,int speed){
  if(speed > 100)speed = 100;
  else if(speed < -100) speed = -100;
  if(ch == 1){
    if(speed > 0){
      setStateMotor(6,speed,1);
    }
    else{
      setStateMotor(8,speed,1); 
    }
  }
  else {
    if(speed > 0){
      setStateMotor(7,speed,1);
    }
    else {
      setStateMotor(9,speed,1); 
    }
  }
}
long kbexten::map_function(long x_value, long in_min, long in_max, long out_min, long out_max){
	return (x_value - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
void kbexten::set_pin_PID(uint8_t PID_S1,uint8_t PID_S2,uint8_t PID_S3,uint8_t PID_S4){
	PID_num_sensor = 0;
	if(PID_S1 != 0 ){PID_num_sensor ++;}
	if(PID_S2 != 0 ){PID_num_sensor ++;}
	if(PID_S3 != 0 ){PID_num_sensor ++;}
	if(PID_S4 != 0 ){PID_num_sensor ++;}
	sensor_pin[0] = PID_S1;
	sensor_pin[1] = PID_S2;
	sensor_pin[2] = PID_S3;
	sensor_pin[3] = PID_S4;
}
int kbexten::readLine() {
	bool onLine = false;
  long avg = 0;
  long sum = 0;
  for (uint8_t i = 0; i < PID_num_sensor ; i++) 
  {
    long value = map_function(readAnalog(sensor_pin[i]), min_sensor_values[i], max_sensor_values[i], 100, 0);    
    if (value > 30) { 
      onLine = true;
    }
    if (value > 5){
      avg += (long)value * (i * 100);
      sum += value;
    }
  }
  if (!onLine)
  {
    if (_lastPosition < (((PID_num_sensor -1)*100)/2) ){
      return 0;
    }
    else{
      return ((PID_num_sensor -1)*100);
    }
  }
  _lastPosition = avg / sum;
  return _lastPosition;
}
void kbexten::_Run_PID(int speed_motor_input,float kp,float ki,float kd){
  uint16_t setpoint = 0;
  float present_position = 0;
  float errors = 0;
  float output = 0;
  float integral = 0;
  float derivative = 0;
  
    
    present_position = readLine();
    setpoint = (((PID_num_sensor -1)*100)/2) ;
    errors = setpoint - present_position;
    integral = integral + errors ;
    derivative = (errors - previous_error) ;
    output = kp * errors + ki * integral + kd * derivative;
    previous_error = errors;
    int max_output = speed_motor_input + 30;

    int speed_motor1 = speed_motor_input - output;
    int speed_motor2 = speed_motor_input + output;

    if(speed_motor1 > max_output ) speed_motor1 = max_output;
    else if(speed_motor1 < 0) speed_motor1 = 0;

    if(speed_motor2 > max_output ) speed_motor2 = max_output;
    else if(speed_motor2 < 0) speed_motor2 = 0;


    motor(1,speed_motor1);
    motor(2,speed_motor2);
}
// void kbexten::readAllSensor(){
// 	sprintf(strBuff, "A0=%d,A1=%d,A2=%d,A3=%d",readAnalog(29),readAnalog(28),readAnalog(27),readAnalog(26));
// }

