#ifndef __KBEXTEN_H__
#define __KBEXTEN_H__


#include <math.h>
#include <string.h>
#include "driver.h"
#include "device.h"
#include "i2c-dev.h"
#include "driver/uart.h"
#include "kidbright32.h"

// This project clone form KidmotorV4 by ArtronShop

#define MODE_INPUT 0
#define MODE_OUTPUT 1

class kbexten : public Device {
	private:		
		I2CDev *i2c;
		uint8_t kbextenData[2];
		char strBuff[20];
		
		

	public:
		uint8_t PID_num_sensor = 3;
		uint16_t sensor_pin[4] = {29, 28, 27,26}; // พอตเซ็นเซอร์ที่ใช้งาน
		uint16_t min_sensor_values[4] = {100, 100, 100, 100}; //ค่าที่อ่านได้น้อยสุดหรือ สีดำ
		uint16_t max_sensor_values[4] = {1000, 1000, 1000, 1000} ; //ค่าที่อ่านได้มากสุด สีขาว

		uint16_t state_on_Line = 0;
		uint16_t _lastPosition = 0;
		float previous_error = 0;

		// constructor
		kbexten(int bus_ch, int dev_addr) ;
		
		// override
		void init(void);
		void process(Driver *drv);
		int prop_count(void);
		bool prop_name(int index, char *name);
		bool prop_unit(int index, char *unit);
		bool prop_attr(int index, char *attr);
		bool prop_read(int index, char *value);
		bool prop_write(int index, char *value);
		
		// method
		void setStateMotor(uint8_t state, uint8_t speed,int time_delay);
		void setServoMotor(uint8_t ch, uint8_t degree,int time_delay);
		void writeDigital(uint8_t ch,uint8_t status);
		int readDigital(uint8_t ch,uint8_t pinMode);
		int readAnalog(uint8_t ch);
		int readDistance(uint8_t Echo,uint8_t Trig);
		void motor(uint8_t ch,int speed);
		long map_function(long x_value, long in_min, long in_max, long out_min, long out_max);
		void set_pin_PID(uint8_t PID_S1,uint8_t PID_S2,uint8_t PID_S3,uint8_t PID_S4);
		int readLine();
		void _Run_PID(int speed_motor_input,float kp,float ki,float kd);
		// void readAllSensor();

		
};

#endif
